package app.main;

import ryulib.game.GameControl;
import ryulib.game.GamePlatformInfo;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;

public class BackGround extends GameControl {

	private static final int BACKROUND_SPEED_SLOW = 25;
	private static final int BACKROUND_SPEED_FAST = 50;

	public BackGround(Context context) {
		super(null);
		
		Resources resources = context.getResources();
		
		_BackGround_A.setBitmap(
				BitmapFactory.decodeResource(resources, R.drawable.background_a)
		);
		_BackGround_A.setSpeed(BACKROUND_SPEED_SLOW);

		_BackGround_B.setBitmap(
				BitmapFactory.decodeResource(resources, R.drawable.background_b)
		);
		_BackGround_B.setSpeed(BACKROUND_SPEED_FAST);
	}

	private Canvas _Canvas = null;
	private Paint _Paint = null;
	
	private BackGroundImage _BackGround_A = new BackGroundImage();
	private BackGroundImage _BackGround_B = new BackGroundImage();
	
	@Override
	protected void onStart(GamePlatformInfo platformInfo) {
		_Canvas = platformInfo.getCanvas();
		_Paint = platformInfo.getPaint();
	}
	
	@Override
	protected void onDraw(GamePlatformInfo platformInfo) {
		long tick = platformInfo.getTick();
		
		_BackGround_A.Draw(_Canvas, _Paint, tick);
		_BackGround_B.Draw(_Canvas, _Paint, tick);
	}
	
}
