package ryulib.game;

import java.util.HashMap;

import ryulib.ValueList;

public class SceneManager {
	
	public SceneManager(GamePlatform gamePlatform) {
		super();
		
		_GamePlatform = gamePlatform;
	}
	
	private HashMap<String, IScene> _SceneList = new HashMap<String, IScene>();
	private String _ActiveName = "";
	private IScene _ActiveScene = null;
	
	// Property 
	private GamePlatform _GamePlatform = null;
	
	public synchronized void Clear() {
		_SceneList.clear();
	}
	
	public synchronized void Add(String name, IScene scene) {
		_SceneList.put(name, scene);
		scene.setSceneManager(this);
	}
	
	public synchronized void Remove(String name) {
		_SceneList.remove(name);
	}
	
	public synchronized void setActiveName(String name, ValueList params) {
		IScene scene = _SceneList.get(name);
		// TODO : raise Exception
		if (scene == null) return;
		
		IScene temp = _ActiveScene;
		
		_ActiveName = name;
		_ActiveScene = scene;
		
		if (temp != null) temp.ActionOut(scene);
		scene.ActionIn(temp, params);
	}
	
	public String getActiveName() {
		return _ActiveName;
	}
	
	public IScene getActiveScene() {
		return _ActiveScene;
	}

	public GamePlatform getGamePlatform() {
		return _GamePlatform;
	}

}
