package app.main;

import ryulib.game.GameControl;
import ryulib.game.GamePlatformInfo;
import android.graphics.Canvas;
import android.graphics.Paint;
import app.resources.ResourceAsteroid;

public class Asteroid extends GameControl {

	private static final int _ANIMATIONINTERVAL = 100;
	private static final int _SPEED = 100;

	public Asteroid(int x, int y) {
		super(null);
	
		_X = x;
		_Y = y;
	}

	private Canvas _Canvas = null;
	private Paint _Paint = null;
	
	private int _X = 0;
	private int _Y = 0;
	private Scroll _Scroll = new Scroll(_SPEED);
	
    private int _BitmapIndex = 0;
    private long _TickCount = 0;
    
	@Override
	protected void onStart(GamePlatformInfo platformInfo) {
		_Canvas = platformInfo.getCanvas();
		_Paint = platformInfo.getPaint();
	}
	
	@Override
	protected void onTick(GamePlatformInfo platformInfo) {
		long tick = platformInfo.getTick();
		
		_TickCount = _TickCount + tick;
		if (_TickCount >= _ANIMATIONINTERVAL) {
			_TickCount = 0;
			_BitmapIndex++;
			if (_BitmapIndex >= ResourceAsteroid.getInstance().getCount()) {
				_BitmapIndex = 0;
			}
		}
		
		// ʴ _Scroll.getSpeed() ŭ ӵ  ̵ Ѵ.
		_X = _X - _Scroll.Move(tick);

		// ȭ鿡   Ѵ.
		if (_X < -(ResourceAsteroid.SIZE)) this.Delete(); 
	}
	
	@Override
	protected void onDraw(GamePlatformInfo platformInfo) {
		_Canvas.drawBitmap(
				ResourceAsteroid.getInstance().getBitmap(_BitmapIndex), 
				_X, _Y, 
				_Paint
		);
	}
	
}
