package app.resources;

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import app.main.R;

public class ResourceAsteroid {

	private static ResourceAsteroid _Instance = new ResourceAsteroid();

	public static ResourceAsteroid getInstance(){
		return _Instance;
	}
	
	private ResourceAsteroid() {}
	
    private Bitmap[] _Bitmaps = null;

    public static final int SIZE = 64;
	
	public Bitmap getBitmap(int index) {
    	loadBitmaps();
    	return _Bitmaps[index];
    }
    
    public int getCount() {
    	loadBitmaps();
    	return _Bitmaps.length;
    }
    
    private void loadBitmaps() {
    	// ̹ εǾ  Ѵ.
    	if (_Bitmaps != null) return;
    	
		_Bitmaps = new Bitmap[12];
		
		Resources resources = Resource.getInstance().getResources();  
		
        _Bitmaps[11] = BitmapFactory.decodeResource(resources, R.drawable.asteroid01);
        _Bitmaps[10] = BitmapFactory.decodeResource(resources, R.drawable.asteroid02);
        _Bitmaps[ 9] = BitmapFactory.decodeResource(resources, R.drawable.asteroid03);
        _Bitmaps[ 8] = BitmapFactory.decodeResource(resources, R.drawable.asteroid04);
        _Bitmaps[ 7] = BitmapFactory.decodeResource(resources, R.drawable.asteroid05);
        _Bitmaps[ 6] = BitmapFactory.decodeResource(resources, R.drawable.asteroid06);
        _Bitmaps[ 5] = BitmapFactory.decodeResource(resources, R.drawable.asteroid07);
        _Bitmaps[ 4] = BitmapFactory.decodeResource(resources, R.drawable.asteroid08);
        _Bitmaps[ 3] = BitmapFactory.decodeResource(resources, R.drawable.asteroid09);
        _Bitmaps[ 2] = BitmapFactory.decodeResource(resources, R.drawable.asteroid10);
        _Bitmaps[ 1] = BitmapFactory.decodeResource(resources, R.drawable.asteroid11);
        _Bitmaps[ 0] = BitmapFactory.decodeResource(resources, R.drawable.asteroid12);
    }
	  
}
