package app.main;

import ryulib.game.GamePlatform;
import android.app.Activity;
import android.os.Bundle;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import app.resources.Resource;

public class Main extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        Resource.getInstance().setContext(this);

        _GamePlatform = new GamePlatform(this);
        _GamePlatform.setLayoutParams(
        		new LinearLayout.LayoutParams(
        				ViewGroup.LayoutParams.FILL_PARENT, 
        				ViewGroup.LayoutParams.FILL_PARENT, 
        				0.0F
        		)
        );
        
        setContentView(_GamePlatform);
        
        _Background = new Background(null);
        _GamePlatform.AddControl(_Background);
        
        _Asteroids = new Asteroids(null);
        _GamePlatform.AddControl(_Asteroids);        

        _Ship = new Ship(null);
        _GamePlatform.AddControl(_Ship);
    }
    
    private GamePlatform _GamePlatform = null;
    private Background _Background = null;
    private Asteroids _Asteroids = null;
    private Ship _Ship = null;
    
}