package app.main;

import ryulib.game.GameControl;
import ryulib.game.GamePlatformInfo;
import ryulib.game.HitArea;
import ryulib.graphic.Boundary;
import android.graphics.Canvas;
import android.graphics.Paint;
import app.resources.ResourceAsteroid;

public class Asteroid extends GameControl {

	private static final int _ANIMATIONINTERVAL = 100;
	private static final int _SPEED = 100;
	private static final int _HORIZONTAL_MARGINE = 5;
	private static final int _VERTICAL_MARGINE   = 5;

	public Asteroid(int x, int y) {
		super(null);
	
		_X = x;
		_Y = y;
		
		_HitArea.Add(_HitBoundary);
	}

	private Canvas _Canvas = null;
	private Paint _Paint = null;
	
	private int _X = 0;
	private int _Y = 0;
	private Scroll _Scroll = new Scroll(_SPEED);
	
	private AnimationCounter _AnimationCounter = 
		new AnimationCounter(
				_ANIMATIONINTERVAL, 
				ResourceAsteroid.getInstance().getCount()
		);
	
	// 浹 ˻   ڽ ϰ ִ  ˷ش.  
	private HitArea _HitArea = new HitArea();

	// Boundary Rect   Ѵ.  
	private Boundary _HitBoundary = new Boundary(0, 0, 0, 0);
	
	@Override
	protected HitArea getHitArea() {
		_HitBoundary.setBoundary(
				_X + _HORIZONTAL_MARGINE, 
				_Y + _VERTICAL_MARGINE, 
				_X + ResourceAsteroid.SIZE - _HORIZONTAL_MARGINE*2, 
				_Y + ResourceAsteroid.SIZE - _VERTICAL_MARGINE*2
		);		
		
		return _HitArea;
	}
	
	@Override
	protected void onStart(GamePlatformInfo platformInfo) {
		_Canvas = platformInfo.getCanvas();
		_Paint = platformInfo.getPaint();
	}
	
	@Override
	protected void onTick(GamePlatformInfo platformInfo) {
		long tick = platformInfo.getTick();
		
		_AnimationCounter.Tick(tick);
		
		// ʴ _Scroll.getSpeed() ŭ ӵ  ̵ Ѵ.
		_X = _X - _Scroll.Move(tick);
		
		// ȭ鿡   Ѵ.
		if (_X < (-ResourceAsteroid.SIZE)) this.Delete(); 
	}
	
	@Override
	protected void onDraw(GamePlatformInfo platformInfo) {
		_Canvas.drawBitmap(
				ResourceAsteroid.getInstance().getBitmap(
						_AnimationCounter.getIndex()
				),
				_X,	_Y, 
				_Paint
		);
	}
	
}
