package app.main;

import ryulib.game.GameControl;
import ryulib.game.GameControlGroup;
import ryulib.game.GamePlatformInfo;
import ryulib.game.HitArea;
import ryulib.graphic.Boundary;
import android.graphics.Canvas;
import android.graphics.Paint;
import app.resources.ResourceLaser;

public class Laser extends GameControl {

	private static final int _SPEED = 200;
	private static final int _HORIZONTAL_MARGINE = 0;
	private static final int _VERTICAL_MARGINE   = 0;
	
	public Laser(GameControlGroup gameControlGroup) {
		super(gameControlGroup);
		
		_HitArea.Add(_HitBoundary);
	}
	
	private Canvas _Canvas = null;
	private Paint _Paint = null;
	
	private int _X = 0;
	private int _Y = 0;
	private Scroll _Scroll = new Scroll(_SPEED);
	
	// 浹 ˻   ڽ ϰ ִ  ˷ش.  
	private HitArea _HitArea = new HitArea();

	// Boundary Rect   Ѵ.  
	private Boundary _HitBoundary = new Boundary(0, 0, 0, 0);
	
	@Override
	protected HitArea getHitArea() {
		_HitBoundary.setBoundary(
				_X + _HORIZONTAL_MARGINE, 
				_Y + _VERTICAL_MARGINE, 
				_X + ResourceLaser.WIDTH - _HORIZONTAL_MARGINE*2, 
				_Y + ResourceLaser.HEIGHT - _VERTICAL_MARGINE*2
		);		
		
		return _HitArea;
	}
	
	public void Init(int x, int y) {
		_X = x - ResourceLaser.WIDTH;
		_Y = y - (ResourceLaser.HEIGHT / 2);
	}

	@Override
	protected void onStart(GamePlatformInfo platformInfo) {
		_Canvas = platformInfo.getCanvas();
		_Paint = platformInfo.getPaint();
	}
	
	@Override
	protected void onDraw(GamePlatformInfo platformInfo) {
		_Canvas.drawBitmap(ResourceLaser.getInstance().getBitmap(), _X, _Y, _Paint);
		
		GameControl GameControl = this.CheckCollision(this);		
		if ((GameControl != null) && (GameControl instanceof Asteroid)) {
			this.Delete();
			GameControl.Delete();
		}
		
		_X = _X + _Scroll.Move(platformInfo.getTick());
		
		if (_X > _Canvas.getWidth()) this.Delete();
	}
}
