package app.main;

import java.util.Random;

import app.resources.ResourceAsteroid;

import ryulib.game.GameControl;
import ryulib.game.GameControlGroup;
import ryulib.game.GamePlatformInfo;

public class Asteroids extends GameControl {

	public Asteroids(GameControlGroup gameControlGroup) {
		super(gameControlGroup);
	}
	
	private Random _Random = new Random();
	private long _AdventInterval = 250;
	private long _AdventCount = 0;
	
	@Override
	protected void onTick(GamePlatformInfo platformInfo) {
		long tick = platformInfo.getTick();
		
		_AdventCount = _AdventCount + tick;
		if (_AdventCount >= _AdventInterval) {
			_AdventCount = _AdventCount - _AdventInterval;
			
			// ֱ   ʰ, ϰ ߻ Ų.
			if (_Random.nextInt(2) == 1) createAsteroid(platformInfo);
		}
	}
	
	private void createAsteroid(GamePlatformInfo platformInfo) {
		Asteroid asteroid = 
			new Asteroid(
					platformInfo.getCanvas().getWidth(), 
					_Random.nextInt(platformInfo.getCanvas().getWidth()-ResourceAsteroid.SIZE)
			);
		this.getGameControlGroup().AddControl(asteroid);
	}
	
}
