package app.main;

import app.resources.ResourceSound;
import ryulib.game.GameControl;
import ryulib.game.GameControlGroup;

public class Lasers extends GameControl {

	private static final int _FIRE_INTERVAL = 250;

	public Lasers(GameControlGroup gameControlGroup) {
		super(gameControlGroup);

	}
	
	private long _OldTick = 0;
	
	public void Fire(int x, int y) {
		long tick = System.currentTimeMillis();

		if ((_OldTick == 0) || ((tick-_OldTick) >= _FIRE_INTERVAL)) {
			Laser laser = new Laser(null);
			laser.Init(x, y);
			this.getGameControlGroup().AddControl(laser);
			
			ResourceSound.getInstance().Fire();
			
			_OldTick = tick;
		}
	}

}
