package app.resources;

import android.media.AudioManager;
import android.media.SoundPool;
import app.main.R;

public class ResourceSound {
	
	// ִ Ʈ 
	private static final int _STREAM_COUNT = 4;
	
	private static ResourceSound _Instance = new ResourceSound();

	public static ResourceSound getInstance(){
		return _Instance;
	}
	
	private ResourceSound() {}
	  
	private SoundPool _SoundPool  = new SoundPool(_STREAM_COUNT, AudioManager.STREAM_MUSIC, 0);
	
	private int _Fire = -1;	
	private int _Boom = -1;
	
	public void Prepare() {
		_Fire = _SoundPool.load(
				Resource.getInstance().getContext(), 
				R.raw.fire, 
				1
			);   

		_Boom = _SoundPool.load(
				Resource.getInstance().getContext(), 
				R.raw.boom, 
				1
			);   
	}
	
	public void Fire() {
		_SoundPool.play(_Fire, 1, 1, 0, 0, 1);
	}
	
	public void Boom() {
		_SoundPool.play(_Boom, 1, 1, 0, 0, 1);
	}

}
